// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

using System;
using System.Collections.Generic;
using System.Collections.Immutable;
using System.Threading.Tasks;
using Pulumi.Serialization;

namespace Pulumi.Checkly
{
    /// <summary>
    /// ## Example Usage
    /// 
    /// ```csharp
    /// using Pulumi;
    /// using Checkly = Pulumi.Checkly;
    /// 
    /// class MyStack : Stack
    /// {
    ///     public MyStack()
    ///     {
    ///         var maintenance_1 = new Checkly.MaintenanceWindow("maintenance-1", new Checkly.MaintenanceWindowArgs
    ///         {
    ///             EndsAt = "2014-08-25T00:00:00.000Z",
    ///             RepeatEndsAt = "2014-08-24T00:00:00.000Z",
    ///             RepeatInterval = 1,
    ///             RepeatUnit = "MONTH",
    ///             StartsAt = "2014-08-24T00:00:00.000Z",
    ///             Tags = 
    ///             {
    ///                 "production",
    ///             },
    ///         });
    ///     }
    /// 
    /// }
    /// ```
    /// </summary>
    [ChecklyResourceType("checkly:index/maintenanceWindow:MaintenanceWindow")]
    public partial class MaintenanceWindow : Pulumi.CustomResource
    {
        /// <summary>
        /// The end date of the maintenance window.
        /// </summary>
        [Output("endsAt")]
        public Output<string> EndsAt { get; private set; } = null!;

        /// <summary>
        /// The maintenance window name.
        /// </summary>
        [Output("name")]
        public Output<string> Name { get; private set; } = null!;

        /// <summary>
        /// The date on which the maintenance window should stop repeating.
        /// </summary>
        [Output("repeatEndsAt")]
        public Output<string?> RepeatEndsAt { get; private set; } = null!;

        /// <summary>
        /// The repeat interval of the maintenance window from the first occurrence.
        /// </summary>
        [Output("repeatInterval")]
        public Output<int?> RepeatInterval { get; private set; } = null!;

        /// <summary>
        /// The repeat cadence for the maintenance window. Possible values `DAY`, `WEEK` and `MONTH`.
        /// </summary>
        [Output("repeatUnit")]
        public Output<string?> RepeatUnit { get; private set; } = null!;

        /// <summary>
        /// The start date of the maintenance window.
        /// </summary>
        [Output("startsAt")]
        public Output<string> StartsAt { get; private set; } = null!;

        /// <summary>
        /// The names of the checks and groups maintenance window should apply to.
        /// </summary>
        [Output("tags")]
        public Output<ImmutableArray<string>> Tags { get; private set; } = null!;


        /// <summary>
        /// Create a MaintenanceWindow resource with the given unique name, arguments, and options.
        /// </summary>
        ///
        /// <param name="name">The unique name of the resource</param>
        /// <param name="args">The arguments used to populate this resource's properties</param>
        /// <param name="options">A bag of options that control this resource's behavior</param>
        public MaintenanceWindow(string name, MaintenanceWindowArgs args, CustomResourceOptions? options = null)
            : base("checkly:index/maintenanceWindow:MaintenanceWindow", name, args ?? new MaintenanceWindowArgs(), MakeResourceOptions(options, ""))
        {
        }

        private MaintenanceWindow(string name, Input<string> id, MaintenanceWindowState? state = null, CustomResourceOptions? options = null)
            : base("checkly:index/maintenanceWindow:MaintenanceWindow", name, state, MakeResourceOptions(options, id))
        {
        }

        private static CustomResourceOptions MakeResourceOptions(CustomResourceOptions? options, Input<string>? id)
        {
            var defaultOptions = new CustomResourceOptions
            {
                Version = Utilities.Version,
                PluginDownloadURL = "https://github.com/checkly/pulumi-checkly/releases/download/${VERSION}",
            };
            var merged = CustomResourceOptions.Merge(defaultOptions, options);
            // Override the ID if one was specified for consistency with other language SDKs.
            merged.Id = id ?? merged.Id;
            return merged;
        }
        /// <summary>
        /// Get an existing MaintenanceWindow resource's state with the given name, ID, and optional extra
        /// properties used to qualify the lookup.
        /// </summary>
        ///
        /// <param name="name">The unique name of the resulting resource.</param>
        /// <param name="id">The unique provider ID of the resource to lookup.</param>
        /// <param name="state">Any extra arguments used during the lookup.</param>
        /// <param name="options">A bag of options that control this resource's behavior</param>
        public static MaintenanceWindow Get(string name, Input<string> id, MaintenanceWindowState? state = null, CustomResourceOptions? options = null)
        {
            return new MaintenanceWindow(name, id, state, options);
        }
    }

    public sealed class MaintenanceWindowArgs : Pulumi.ResourceArgs
    {
        /// <summary>
        /// The end date of the maintenance window.
        /// </summary>
        [Input("endsAt", required: true)]
        public Input<string> EndsAt { get; set; } = null!;

        /// <summary>
        /// The maintenance window name.
        /// </summary>
        [Input("name")]
        public Input<string>? Name { get; set; }

        /// <summary>
        /// The date on which the maintenance window should stop repeating.
        /// </summary>
        [Input("repeatEndsAt")]
        public Input<string>? RepeatEndsAt { get; set; }

        /// <summary>
        /// The repeat interval of the maintenance window from the first occurrence.
        /// </summary>
        [Input("repeatInterval")]
        public Input<int>? RepeatInterval { get; set; }

        /// <summary>
        /// The repeat cadence for the maintenance window. Possible values `DAY`, `WEEK` and `MONTH`.
        /// </summary>
        [Input("repeatUnit")]
        public Input<string>? RepeatUnit { get; set; }

        /// <summary>
        /// The start date of the maintenance window.
        /// </summary>
        [Input("startsAt", required: true)]
        public Input<string> StartsAt { get; set; } = null!;

        [Input("tags")]
        private InputList<string>? _tags;

        /// <summary>
        /// The names of the checks and groups maintenance window should apply to.
        /// </summary>
        public InputList<string> Tags
        {
            get => _tags ?? (_tags = new InputList<string>());
            set => _tags = value;
        }

        public MaintenanceWindowArgs()
        {
        }
    }

    public sealed class MaintenanceWindowState : Pulumi.ResourceArgs
    {
        /// <summary>
        /// The end date of the maintenance window.
        /// </summary>
        [Input("endsAt")]
        public Input<string>? EndsAt { get; set; }

        /// <summary>
        /// The maintenance window name.
        /// </summary>
        [Input("name")]
        public Input<string>? Name { get; set; }

        /// <summary>
        /// The date on which the maintenance window should stop repeating.
        /// </summary>
        [Input("repeatEndsAt")]
        public Input<string>? RepeatEndsAt { get; set; }

        /// <summary>
        /// The repeat interval of the maintenance window from the first occurrence.
        /// </summary>
        [Input("repeatInterval")]
        public Input<int>? RepeatInterval { get; set; }

        /// <summary>
        /// The repeat cadence for the maintenance window. Possible values `DAY`, `WEEK` and `MONTH`.
        /// </summary>
        [Input("repeatUnit")]
        public Input<string>? RepeatUnit { get; set; }

        /// <summary>
        /// The start date of the maintenance window.
        /// </summary>
        [Input("startsAt")]
        public Input<string>? StartsAt { get; set; }

        [Input("tags")]
        private InputList<string>? _tags;

        /// <summary>
        /// The names of the checks and groups maintenance window should apply to.
        /// </summary>
        public InputList<string> Tags
        {
            get => _tags ?? (_tags = new InputList<string>());
            set => _tags = value;
        }

        public MaintenanceWindowState()
        {
        }
    }
}
